# Guidelime

A WoW Classic addon for leveling guides with automatic progress updates

## What does it do?

Guides are shown as a list of steps where the progress is updated automatically as much as possible (quests picked up / completed, quest 
items looted / mobs killed, etc). Only for some steps completion has to be confirmed manually (such as resupplying, getting new skills, etc). 
Locations referenced in the guide are shown on the map and minimap. Also there is an arrow pointing in the direction towards the next step.

The addon comes with an editor so even if the number of guides included is small (yet) it is very easy to create your own guides or to import
your favorite guide.

<img src="https://i.imgur.com/6aCB623.png" alt="Guidelime"/>

*This is for WoW Classic. It will not run on private servers and/or BFA. (If you only want to take a look at the editor e.g., it will load on BFA if you select "load out of date addons".)*

## Where do I find guides for the addon?

See <a href="https://github.com/max-ri/Guidelime/wiki/GuideList">list of all available guides</a> for a complete list of guides that have been written for Guidelime so far.

## How do I write a guide?

<a href="https://github.com/max-ri/Guidelime/wiki/WriteAGuide">How do I write a guide?</a>

## How do I publish a guide?

<a href="https://github.com/max-ri/Guidelime/wiki/PublishAGuide">How do I publish a guide?</a>

## How do I install the addon?

When you download the zip file from this page (click "Clone or Download" then "Download Zip") you will find a *Guidelime* folder (inside the *Guidelime-master* folder). Copy this folder into your *Addons* folder.

By using this method you will always get to most recent version of the addon (*master*) including all changes that are being made as soon as they are published.

Alternatively you can also download the addon from https://www.curseforge.com/wow/addons/guidelime or install it via the Twitch client. This way you will get the latest stable release. (Which currently is also being updated in average once a day.)

## What is missing?

#### More guides

Right now there is only a limited amount of guides available for the addon. At least for alliance full 1-60 guides are available. A complete Horde guide will be added later on.

If you are a guide creator and you have your own guides that you would like to see in Guidelime feel free to contact me.

#### Documentation

Instructions on how to put your own guides into a separate addon will be added soon.

#### Improved editor

The editor will soon be complemented with powerful features for importing guides so that creating your own guides will be even easier.

#### Localization

The German version will be finished soon. A Spanish version will follow afterwards. If anyone would volunteer to do translations for other languages please contact me.

The guides itself are language specific. The guides I am currently working on are in English language only. But using the editor you can create guides in your own language.

## How do I open the window again after I closed it accidentally?

Type `/lime` or go to *Interface Options*, *AddOns*, *Guidelime*, *Options* and click on show window.

## Contact 

Discord: https://discord.gg/kDXMHsV

You'd like to support me?

<a href='https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=max_r_%40web.de&item_name=Guidelime&currency_code=EUR'><img src="https://www.paypalobjects.com/en_US/i/btn/btn_donate_LG.gif"/></a>
